-- 今日收获
Lua_HarvestPackWindow = class("Lua_HarvestPackWindow", Lua_Window);
function Lua_HarvestPackWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_HarvestPackWindow";
	self.skinName = "HarvestPackWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
	self.showCloseText = true;
	self.closeTextPosY = -540;
end

function Lua_HarvestPackWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.onHarvestNum = 0;

	self.scrollContainer = UICreate.createScrollContainer(self.content, 0, 15, 570, 632);
	self.scrollContainer.horizontal = false;
	self.scrollContainer.vertical = true;
	self.scrollContainer.movementTypeValue = 1;
	self.scrollContainer.elasticity = 0.3;
	self.scrollContainer.inertia = true;
	self.scrollContainer:setScrollPivot(1);
	self.scrollContainer:setScrollAnchor(0.5, 1, 0.5, 1);
	self.scrollContainer:setScrollPosition(0, 0, 0);
	self.scrollContainer:addMask();
	self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
	self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);

	self.sub = self.scrollContainer.scrollContent;
	self.subItemArr = Array();

	self.subBtn:setGray(true);
	self.subBtn:addClickFuntion(self, self.onSubBtnClick); -- 一键翻牌

	self:addLuaEvent("ON_HORT_ITEM", self, self.onHortItem); -- 点击伤害统计，向服务端发送数据 DagList的cell元素
	self:addLuaEvent("ON_HARVEST_ITEM", self, self.onHarvestItem); -- 点击翻牌，向服务端发送数据 DragList的cell元素
	self:addLuaEvent("UPDATE_SUBBTN_STATE", self, self.updateSubBtnState); -- 更新一键翻牌按钮的状态 DragList的cell元素
	self:addLuaEvent("UPDATE_HARVEST_INFO", self, self.updateHarvestInfo);
end

function Lua_HarvestPackWindow:dispose()
	if self.scrollContainer ~= nil then
		self.scrollContainer:dispose();
		self.scrollContainer = nil;
	end
	self.sub = nil;
	Lua_CommonUtil.removeTimer(self, self.updateListCanDrag);
	self:superCall("dispose");
end

function Lua_HarvestPackWindow:showWin(param)
	self:superCall("showWin",param);

	-- param 1：单人 2：队伍
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sHarvest(param);
end

function Lua_HarvestPackWindow:updateHarvestInfo()
	self:updateSubBtnState(); -- 更新一键翻牌按钮的状态
	self:showDrawInfo(); -- 更新draglist
end

-- 更新一键翻牌按钮的状态
function Lua_HarvestPackWindow:updateSubBtnState(state)
	if state then
		self.onHarvestNum = self.onHarvestNum + 1;
	end
	self.isHavoHarvest = DataCenter.equipCopyData.isHavoHarvest;
	self.subBtn:setGray(not self.isHavoHarvest);
end

function Lua_HarvestPackWindow:showDrawInfo()
	local arr = DataCenter.equipCopyData.harvestInfo;
	local num = arr:getSize();
	local count = self.subItemArr:getSize();
	local len = num > count and num or count;
	local data;
	local item;
	for i = 1, len do
		item = self.subItemArr[i];
		if item == nil then
			item = Lua_HarvestItem.new(self.sub);
			item:setRectAnchor(1);
			self.subItemArr:add(item);
		end

		data = arr[i];
		if data ~= nil then
			item:setData(data);
			item:setLocation(-190 + (i - 1) % 3 * 190, -160 - (Mathf.Ceil(i / 3) - 1) * 316);
		end
		item:setEnable(data ~= nil);
	end
	self.scrollContainer:setScrollSize(700, Mathf.Ceil(num / 3) * 316);
end

function Lua_HarvestPackWindow:onHarvestItem(record_id)
	if self.subBtnState then
		if self.sendMsg == nil then -- 一键翻牌动画返回多次，这里只需要请求一次就可以了
			self.sendMsg = true;
			Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sReceiveReward(self.showData, 0);
		end
	else
		Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sReceiveReward(self.showData, record_id);
	end
	self.onHarvestNum = self.onHarvestNum - 1;
end

function Lua_HarvestPackWindow:onHortItem(record_id)
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sLookHort(self.showData, record_id);
end

-- 点击一键翻牌时，所有卡牌的反转特效
function Lua_HarvestPackWindow:onSubBtnClick()
	self:updateSubBtnState(); -- 更新一键翻牌按钮的状态
	if self.isHavoHarvest == false then
		return;
	end
	self.subBtnState = true;

	local item;
	for i = 1, self.subItemArr:getSize() do
		item = self.subItemArr[i];
		if item.isActive then
			item:onPressClick(false);
		end
	end

	local arr = DataCenter.equipCopyData.harvestInfo;
	for i = 1, arr:getSize() do
		arr[i].is_overreturn = 1; 
	end
	self.subBtn:setGray(true);
end

function Lua_HarvestPackWindow:onMaskClick(go)
	if self.onHarvestNum > 0 then
		return
	end

	self:hide();
end

function Lua_HarvestPackWindow:onMouseDownFun()
    self.startMouseX = CommonUtil.mousePositionX;
    self.startMouseY = CommonUtil.mousePositionY;
    self.startClickTime = getTime();
    self.checkItem = self:checkPressItem();
end

function Lua_HarvestPackWindow:onMouseUpFun()
    if self.checkItem == nil then return end
    local dx = CommonUtil.mousePositionX - self.startMouseX;
    local dy = CommonUtil.mousePositionY - self.startMouseY;
    if getTime() - self.startClickTime <= 0.3 and Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
        self.checkItem:onPressClick(true);
    end
end

function Lua_HarvestPackWindow:checkPressItem()

    if self.subItemArr ~= nil then
        local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
        local item;
       	for i = 1, self.subItemArr:getSize() do
       		item = self.subItemArr[i];
            if item.isActive and item:checkInBound(winPos.x, winPos.y) then
                return item;
            end
        end
    end
    return nil;
end


















Lua_HarvestItem = class("Lua_HarvestItem", Lua_DisplayObject);
function Lua_HarvestItem:ctor(p)
	self:superCall("ctor", p, "HarvestItem_skin");
end

function Lua_HarvestItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setCanClick(false);
	self.itemIcon:setLocation(-1.5, 37, 0);
	self.itemIcon:setScale(0.8, 0.8);

	self.hurtBtn:addClickFuntion(self, self.onHurtBtnClick);
end

function Lua_HarvestItem:checkInBound(posX, posY)
	local minX = self.centerPosX - self.bg.width / 2;
	local maxX = self.centerPosX + self.bg.width / 2;
	local minY = self.centerPosY - self.bg.height / 2;
	local maxY = self.centerPosY + self.bg.height / 2;
	if posX >= minX and posX <= maxX and posY >= minY and posY <= maxY then
		return true;
	end
	return false
end

function Lua_HarvestItem:setData(data)
	self.data = data;
	if data == nil then
		return;
	end
	self.fight_grade = data.data.fight_grade;
	self.isShowHarvest = data.is_overreturn == 1; -- true已翻牌 false未翻牌

	self.showIcon:setAltas("equipcopy_atlas_2","xui_jmd_label_"..6-self.fight_grade);
	self.showIcon:setEnable(true);
	self.showIcon:resetSize();
end

function Lua_HarvestItem.Get:isShowHarvest()
	if self._isShowHarvest == nil then
		return false;
	end
	return self._isShowHarvest;
end

function Lua_HarvestItem.Set:isShowHarvest(val)
	self._isShowHarvest = val;
	self:updateShowHarvest();
end

-- 更新展示结果
function Lua_HarvestItem:updateShowHarvest()
	if self.isShowHarvest == false then -- 未翻盘
		self.itemIcon:setEnable(false);
		self.itemNameTxt:setEnable(false);
		self:openItemBack(0);
	else
		local list = self.data.data.reward;
		if list ~= nil and #list > 0 then
			self.tvo = Lua_ToolVo.createToolVo(list[1].id, list[1].amount);
			self.itemIcon:setData(self.tvo);
			self.itemIcon:setEnable(true);

			self.itemNameTxt.text = self.tvo.name;
			self.itemNameTxt:setEnable(true);
			self:openItemBack(1);
		end
	end
end

function Lua_HarvestItem:onPressClick(isShowItem)
	if isShowItem then
		local winPos = LuaUtil.getTouchPosInverseTf(self.mainContent.transform);
		if self.itemIcon.isActive and self.itemIcon:checkInBound(winPos.x, winPos.y) then
			DataCenter.packUtil:showItemInfo(self.tvo);
		end
	end

	if self.data.is_overreturn == 1 then
		return;
	end
	self.data.is_overreturn = 1; -- 记录已翻牌
	Lua_MsgUtil.callFunc("UPDATE_SUBBTN_STATE",true); -- 更新一键翻牌按钮的状态

	self:onStartComplete(); -- 翻牌效果
end

function Lua_HarvestItem:onStartComplete()
	TweenUtil.getInstance():addTween(self.mainContent, 0.3, 0,
	self.x, self.y, 0,
	0, 0, 0,
	0, 1, 1,
	self, self.onAgainComplete, 0, false);
end

function Lua_HarvestItem:onAgainComplete()
	self:openItemBack(1);
	self.isShowHarvest = true;
	TweenUtil.getInstance():addTween(self.mainContent, 1, 0,
	self.x, self.y, 0,
	0, 0, 0,
	1, 1, 1,
	self, self.overComplete, 0, false);
end

function Lua_HarvestItem:overComplete()
	TweenUtil.getInstance():stop(self.mainContent);
	Lua_MsgUtil.callFunc("ON_HARVEST_ITEM", self.data.data.record_id);
end

function Lua_HarvestItem:onHurtBtnClick()
	Lua_MsgUtil.callFunc("ON_HORT_ITEM", self.data.data.record_id);
end

-- 翻牌返回
function Lua_HarvestItem:openItemBack(val)
	if val == 0 then
		self.bg:setAltas("equipcopy_atlas_3","xui_jmd_window_0"..(11+self.fight_grade));
	else
		self.bg:setAltas("equipcopy_atlas_3", "xui_jmd_window_009");
	end
end

function Lua_HarvestItem:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose()
		self.itemIcon = nil;
	end
	TweenUtil.getInstance():stop(self.mainContent);

	self:superCall("dispose");
end