-- 队伍日志
Lua_TeamJournalWindow = class("Lua_TeamJournalWindow", Lua_Window)
function Lua_TeamJournalWindow:ctor()
	self:superCall("ctor");

	self.windowName = "EquipCopyTeamJournalWindow";
	self.skinName = "EquipCopyTeamJournalWindow"; 
	self.showBlackMask = true;
end

function Lua_TeamJournalWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.journalContainer = Lua_DragContainer.new(self.content, 640, 740, Lua_AxisDefine.Vertical);
	self.journalContainer:setLocation(0, -48, 0);

	self:addLuaEvent("EQUIP_COPY_TEAM_JOURNAL", self, self.updatePanel);
	Lua_ProxyManager.getProxy("Lua_EquipCopyProxy"):sLockLog();
end

function Lua_TeamJournalWindow:updatePanel()
	local journalArr = DataCenter.equipCopyData.journalArr;
	self.journalContainer:clearList();
	for i = 1, journalArr:getSize() do
		self.journalContainer:addSubContainer(Lua_TeamJournalItem, journalArr[i], false);
	end
	self.journalContainer:updateChildPos();
	self.journalContainer:moveToIndex(1, true);
end

function Lua_TeamJournalWindow:dispose()
	if self.journalContainer ~= nil then
		self.journalContainer:dispose();
		self.journalContainer = nil;
	end
	self:superCall("dispose");
end










Lua_TeamJournalItem = class("Lua_TeamJournalItem", Lua_DragContainerItem);
function Lua_TeamJournalItem:ctor(p)
	self:superCall("ctor", p, "EquipCopyTeamJournalItem_skin"); 
end

function Lua_TeamJournalItem:buildShowItem()
	self:superCall("buildShowItem");

	self.playBtn:addClickFuntion(self, self.onPlayFightRecord);
end

function Lua_TeamJournalItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.isShowLog = type(data) == "table";
	if self.isShowLog then
		self.timeTxt.text = LanUtil.formateStr("{1}:{2}", os.date("%H", data.log_tick), os.date("%M", data.log_tick));
		self.logContentTxt.text = data.log_content;
		self.playBtn:setEnable(data.log_type == 6 or data.log_type == 7); -- 6胜 7败
	else
		self.historyTxt.text = data;
	end
	self.journalObj:SetActive(self.isShowLog);
	self.historyObj:SetActive(not self.isShowLog);
end

-- 播放战斗记录
function Lua_TeamJournalItem:onPlayFightRecord()
	Lua_ProxyManager.getProxy("Lua_FightProxy"):sFightReplay(self._data.record_list[1], nil, nil, nil, 5);
end

function Lua_TeamJournalItem:getWidth()
	return 640;
end

function Lua_TeamJournalItem:getHeight()
	return self.isShowLog and 110 or 70;
end

function Lua_TeamJournalItem:dispose()
	self:superCall("dispose");
end